﻿#include "multineedlerotary.h"

MultiNeedleRotary::MultiNeedleRotary()
{
    //添加各种参数到列表中
    initRootParasList();
    initRootHMIConfigurationList(m_allParasList);//超级用户界面配置
    initPatternsParasList();
    initSoftwareParasList(m_allParasList);
    initTimeParasList(m_allParasList);
    initMcParasList();
    initWkParasList();

    //初始化控制动作列表
    initOutCtrlList();

    //初始化快捷功能列表
    initShortCutList();

    //初始化辅助功能列表
    initAssistList();

    //初始化花样设置功能列表
    initPatternSetList();

    //参数分类功能
    initParaSetList();

    //初始化传感器列表
    initSensorList();

    //初始化错误代码和状态列表
    initErrorCodeAndStateList();

    //初始化九宫格
    initNinebtn1234();

    //加载右上角信息
    initFileInfoLabel();
}

MultiNeedleRotary::~MultiNeedleRotary()
{

}

void MultiNeedleRotary::initNinebtn1234()
{
    m_nineBtn.insert(1,NineItem(FUN_HEAD_LIFTING,"buttonHeadLifting"));
    m_nineBtn.insert(2,NineItem(FUN_FORWARDORBACK,"buttonForwardOrBack"));
    m_nineBtn.insert(3,NineItem(FUN_PROCESSRESET,"buttonProcessReset"));
    m_nineBtn.insert(4,NineItem(FUN_SIMULATED_STATUS,"buttonSimulatedStatus"));
}

void MultiNeedleRotary::initRootParasList()
{
    //超级用户参数---------------------------
    //超级用户参数-界面配置；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_HMICONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("HMI Configuration"),//界面配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0000 , factory));

    //超级用户参数-界面进入调试模式；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DEBUGMODE, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Interface debug mode"),//界面进入调试模式
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , root));

    //超级用户参数-删除config.ini配置文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETEINI, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete configure file"),//删除配置文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 ,  root));

    //超级用户参数-机器参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_MACHINEPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Machine parameters"),//机器参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0002, factory));

    //超级用户参数-工作参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_WORKPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Work parameters"),//工作参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0003, factory));
}

void MultiNeedleRotary::initPatternsParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    //花样参数-花样设置参数-起始点x；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        PATTERNPARA_SORT_DSTR ,
                                        SET_STARTX, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("startX"),//起始点X
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数-花样设置参数-起始点y；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        PATTERNPARA_SORT_DSTR ,
                                        SET_STARTY, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("startrY"),//起始点Y
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0004, operate));
}

void MultiNeedleRotary::initMcParasList()
{
    //    QTextCodec *cod = QTextCodec::codecForLocale();


}

void MultiNeedleRotary::initWkParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    // 主轴缝纫工作转速, 范围 1--500,单位r/min,默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        0, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing main shaft working speed"),// 主轴缝纫工作转速
                                        2000, 1, 3600, 2000, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // 主轴归零转速, 范围 1--3000，单位r/min，默认 120
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Main shaft zero reset speed"),//主轴归零转速
                                        120, 1, 3000, 120, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // 主轴运转转速, 范围 1--3000，单位r/min，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        111, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Main shaft running speed"),//主轴运转转速
                                        120, 1, 3000, 120, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // xy归零运行速度, 范围 1--500，单位mm/s，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        101, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY zero reset speed"),//xy归零运行速度
                                        100, 1, 500, 100, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // xy空走运行速度, 范围 1--1700，单位mm/s，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        102, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY zero reset speed"),//xy空走运行速度
                                        300, 1, 1700, 300, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // xy手动移动速度1, 范围 1--1000，单位mm/s，默认 10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        105, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 1"),//xy手动移动速度1
                                        10, 1, 1000, 10, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // xy手动移动速度2, 范围 1--1000，单位mm/s，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        106, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 2"),//xy手动移动速度2
                                        100, 1, 1000, 100, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // xy手动移动速度3, 范围 1--1000，单位mm/s，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        107, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 3"),//xy手动移动速度3
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // 工作机头选择
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 1, 0, PARA_VALUE_TYPE_INT,
                                        tr("Work head selection 1"),//工作头选择1
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;allowed:1"), 0, 0, 0x0001, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 2, 0, PARA_VALUE_TYPE_INT,
                                        tr("Work head selection 2"),//工作头选择2
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;allowed:1"), 0, 0, 0x0001, operate));

    // 产量预设
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        33, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Production preset"),// 产量预设
                                        0, 0, S32_MAX, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // 断线检测针数; 0, 不检测断线; 其他, 断线信号连续针数，默认3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        14, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("No. of stitch detect if thread broken"),// 断线检测针数
                                        3, 0, 10, 3, 0, tr("Needle"), tr(""),//针
                                        tr(""), 0, 0, 0x0001, operate));

    // 底线长度, 单位 0.01mm，默认 10000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        17, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Bobbin thread length"),// 底线长度
                                        10000000, 0, S32_MAX, 10000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // 断线检测针数; 0, 不检测断线; 其他, 断线信号连续针数，默认3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        14, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("No. of stitch detect if thread broken"),// 断线检测针数
                                        3, 0, 10, 3, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 换梭芯提醒功能, 0, 不启用该功能; 1, 按长度计数延迟提醒; 2, 按片数计数; 3, 按长度立刻提醒; 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        16, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Bobbin change reminder function"),//换梭芯提醒功能
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        //0, 不启用该功能; 1, 按长度计数延迟提醒; 2, 按片数计数; 3, 按长度立刻提醒; 默认0
                                        tr("Not enabled:0;Delay reminder by length:1;Count by number of slices:2;Immediately reminder by length:3"), 0, 0, 0x0012, operate));

    // 底线长度, 单位 0.01mm，默认 10000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        17, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Bobbin thread length"),// 底线长度
                                        10000000, 1, 10000000, 10000000, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0013, operate));

    // 安全输入允许，位图选择，0, 不允许; 1, 允许;
    // bit0, 光幕;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("Secure input light curtain allows"),//安全输入光幕允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""),0, 0, 0x0010, operate));

    // bit1, 气压;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 2, 0, PARA_VALUE_TYPE_SW,
                                        tr("Safety input pressure allowed"),//安全输入气压允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""),0, 0, 0x0010, operate));

    // bit2, 上电信号;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 3, 0, PARA_VALUE_TYPE_SW,
                                        tr("Safe input power-on signal allowed"),//安全输入上电信号允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""),0, 0, 0x0010, operate));

    // bit4, 安全门
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 4, 0, PARA_VALUE_TYPE_SW,
                                        tr("Safe door allowed"),//安全门允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""),0, 0, 0x0010, operate));

}

void MultiNeedleRotary::initOutCtrlList()
{
    m_allOutCtrlList.clear();
    int showPriority = 1;

    m_allOutCtrlList.append(creatZeroForwardReverseItem(0,showPriority++,tr("X to move motor"),MT_LX));// X向移动电机(归零,正转,反转)
    m_allOutCtrlList.append(creatZeroForwardReverseItem(0,showPriority++,tr("Y to move motor"),MT_LY));// Y向移动电机(归零,正转,反转)


    m_allOutCtrlList.append(creatZeroItem(0,showPriority++,tr("All spindle zero positions"),MT_ALLZ)); // 所有主轴 零位	(归零)
    m_allOutCtrlList.append(creatZeroItem(0,showPriority++,tr("All Spindle Hook Lines positions"),MT_ALLG));  // 所有主轴 勾线	(归零)
    m_allOutCtrlList.append(creatZeroItem(0,showPriority++,tr("All spindle jogs positions"),MT_ALLM)); // 所有主轴 点动	(归零)


}

void MultiNeedleRotary::initShortCutList()
{
    m_allShortCutList.clear();
    int index = 1;;
    m_allShortCutList.append(makeAShortCutItem(0,index++,tr("All_Zero"),"buttonFrameZero",FUN_ALLTOZERO));//全部归零
    m_allShortCutList.append(makeAShortCutItem(0,index++,tr("Front_Back"),"buttonForwardOrBack",FUN_FORWARDORBACK));// 快进快退
    m_allShortCutList.append(makeAShortCutItem(0,index++,tr("AllSpleZero"),"buttonAllToZero",FUN_MT_ALLZ));//所有主轴零位

}

void MultiNeedleRotary::initAssistList()
{
    m_allAssistList.clear();

    m_allAssistList.append(makeAAssistItem(0,0x0001,tr("Signal"),"buttonSensor",ASSIST_SENSOR));//传感器信号
    m_allAssistList.append(makeAAssistItem(0,0x0002,tr("Action"),"buttonControlAction",ASSIST_CONTROLACTION));//控制动作
    m_allAssistList.append(makeAAssistItem(0,0x0003,tr("HMIUpgrade"),"buttonHMIUpgrade",ASSIST_HMIUPGRADE));//界面升级
    m_allAssistList.append(makeAAssistItem(0,0x0004,tr("MCUpgrade"),"buttonMCUpgrade",ASSIST_MCUPGRADE));//主控升级
    m_allAssistList.append(makeAAssistItem(0,0x0006,tr("ParaImport"),"buttonParaImport",ASSIST_PARAIMPORT));//参数导入
    m_allAssistList.append(makeAAssistItem(0,0x0007,tr("ParaExport"),"buttonParaExport",ASSIST_PARAEXPORT));//参数导出
    m_allAssistList.append(makeAAssistItem(0,0x0008,tr("Setting"),"buttonSoftwareSet",ASSIST_SOFTWARESET));//软件设置
    m_allAssistList.append(makeAAssistItem(0,0x0009,tr("Authorize"),"buttonSoftwareAuthor",ASSIST_AUTHORIZATION));//软件授权
    m_allAssistList.append(makeAAssistItem(0,0x000A,tr("Network"),"buttonNetworkManage",ASSIST_NETWORK));//网络管理
    m_allAssistList.append(makeAAssistItem(0,0x000C,tr("Time"),"buttonTimeSet",ASSIST_TIMESET));//时间设置
    m_allAssistList.append(makeAAssistItem(0,0x000F,tr("Version"),"buttonVersionInfo",ASSIST_MCVERSION));//版本信息
    m_allAssistList.append(makeAAssistItem(0,0x0014,tr("Root"),"buttonRoot",ASSIST_ROOT));//超级用户
}

void MultiNeedleRotary::initPatternSetList()
{
    m_allPatternSetList.clear();

    m_allPatternSetList.append(makeAPatternSetItem(0,0x0001,tr("Para"),"buttonPatternPara",PATTERNSET_PATTERNPARA));//花样参数
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0002,tr("Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT));//花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0004,tr("Import"),"buttonPatternImport",PATTERNSET_PATTERNIMPORT));//花样导入
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0005,tr("Export"),"buttonPatternExport",PATTERNSET_PATTERNEXPORT));//花样导出
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0006,tr("Delete"),"buttonPatternDelete",PATTERNSET_PATTERNDELETE));//花样删除

}

void MultiNeedleRotary::initParaSetList()
{
    m_allParaSetList.clear();

    m_allParaSetList.append(makeAParaSetItem(0,0x0001,tr("OperatPara"),"buttonPositionParas",PARASET_SETTING));//设置参数  //操作参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0002,tr("ActionSet"),"buttonSpeedParas",PARASET_ACTION));//动作参数   //动作设定
    m_allParaSetList.append(makeAParaSetItem(0,0x0003,tr("SpeedPara"),"buttonActionParas",PARASET_SPEED));//速度参数  //速度控制参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0004,tr("LimitPara"),"buttonDetectParas",PARASET_POSITION));// 位置参数  //限位参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0005,tr("MCPara"),"buttonSettingParas",PARASET_DETECT));//设置参数    //机器参数

}

void MultiNeedleRotary::initSensorList()
{
    QList <SensorItem> sensorList;

    sensorList.append(makeASensorItem(0x0000, 0, tr("Start button 1")));//启动按钮1
    sensorList.append(makeASensorItem(0x0001, 0, tr("Pause button 1")));//暂停按钮1
    sensorList.append(makeASensorItem(0x0002, 0, tr("Jog button 1")));//点动按钮1
    sensorList.append(makeASensorItem(0x0003, 0, tr("Open frame button 1")));//开框按钮1

}

void MultiNeedleRotary::initErrorCodeAndStateList()
{
    m_allErrorCodeAndStateList.clear();


}

