﻿#ifndef FILESELECTDIALOG_H
#define FILESELECTDIALOG_H

#include <QDialog>
#include "setcontrolstyle.h"
#include "sharedviews/mybutton.h"
#include <QDir>

namespace Ui {
class FileSelectDialog;
}

class FileSelectDialog : public QDialog
{
    Q_OBJECT

public:
    explicit FileSelectDialog(QString filePath, QWidget *parent = 0);
    ~FileSelectDialog();

private slots:
    void on_buttonOk_clicked();

    void on_buttonCancel_clicked();

    void on_buttonPgDn_clicked();

    void on_buttonPgUp_clicked();

private:
    Ui::FileSelectDialog *ui;
    QString m_filePath;
    int m_itemPerPage;
    QList<MyButton*> m_itemBtnList;
    int m_curPages;//花样选择界面当前页数
    int m_pageNums;//总页数
    QList<QString> m_fileNameList;//花样选择界面花样文件列表
    QString m_fileName; //目标文件名

private:
    void initControl();//初始化窗体控件，包括位置、尺寸、样式
    void initResolution1910();//初始化窗体控件为1920x1080分辨率
    void initResolution1006();//初始化窗体控件为1024x600分辨率
    void initControlStyle();//初始化窗体控件样式
    void refreshUi();
    void initData();

public slots:
    void btnclicked();
    QString getFileName();

};

#endif // FILESELECTDIALOG_H
